VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsBpcaCh"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' == Caution for use! ==
'
' When you copy a class module in workbook,
' please perform it by Export & Import from Bpca_Class_V20E.xls by all means.
' (The export file of the class module prepares in the distribution file.)
' If you perform it by Copy & Paste between code windows of VBE,
' Enter/Exit/BeforeUpdate/AfterUpdate and Default-property (Item) do not work.


'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'_/
'_/ [ clsBpcaCh ]  Ver 4.0
'_/
'_/   --- Breakthrough in the Pseudo-Control-Array --- (Excel2000 or later)
'_/
'_/     Control: Label, CommandButton, TextBox, CheckBox
'_/              OptionButton, ToggleButton, ComboBox, SpinButton
'_/
'_/     Event  : Enter, Exit, BeforeUpdate, AfterUpdate
'_/              Change, Click, DblClick, KeyDown, KeyPress, KeyUp
'_/              SpinDown, SpinUp, DropButtonClick
'_/              MouseMove, MouseDown, MouseUp , (FakeExit)
'_/
'_/     AddinBox(K.Tsunoda) CopyRight(C) 2004 Allrights Reserved.
'_/       [http://addinbox.sakura.ne.jp/Breakthrough_P-Ctrl_Arrays_Eng.htm ]
'_/       [Old Site : http://www.h3.dion.ne.jp/~sakatsu/Breakthrough_P-Ctrl_Arrays_Eng.htm ]
'_/
'_/     ----- Japanese version ----
'_/     22 Jun 2004 Ver1.0  1st version
'_/     23 Jun 2004 Ver1.1
'_/     10 Mar 2005 Ver1.2
'_/     15 Apr 2011 Ver1.3
'_/     22 Jul 2014 Ver1.4
'_/     11 Aug 2014 Ver2.0  Enter/Exit/BeforeUpdate/AfterUpdate are supported.
'_/     10 Oct 2016 Ver3.0  FakeExit event & InitFColor/InitBColor properties are added.
'_/     13 Oct 2016 Ver3.1  Correction of the malfunction (When Frame/MultiPage
'_/                         does not have ActiveControl (ActiveControl=Nothing),
'_/                         it becomes the error by FakeExit processing.)
'_/     (Ver3.2 - Ver3.4)   Replace "Japan Holiday module" for Calendar form.
'_/      1 Sep 2020 Ver4.0  Fixed a bug that a runtime error occurs when controls on a worksheet are specified.
'_/
'_/     ----- English version ----
'_/     24 Jul 2014 Ver1.4  1st version
'_/     11 Aug 2014 Ver2.0  Enter/Exit/BeforeUpdate/AfterUpdate are supported.
'_/     10 Oct 2016 Ver3.0  FakeExit event & InitFColor/InitBColor properties are added.
'_/     13 Oct 2016 Ver3.1  Correction of the malfunction (When Frame/MultiPage
'_/                         does not have ActiveControl (ActiveControl=Nothing),
'_/                         it becomes the error by FakeExit processing.)
'_/      1 Sep 2020 Ver4.0  Fixed a bug that a runtime error occurs when controls on a worksheet are specified.
'_/
'_/  The clsBpcaCh class works as a child class of the clsBpca class.
'_/  The user does not use the clsBpcaCh class.
'_/
'_/  [modBpcaConst] module is necessary together.
'_/  It works in x64.
'_/
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/


'------[ API definition for Enter/Exit/BeforeUpdate/AfterUpdate ]-------------
Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

#If VBA7 And Win64 Then
  Private Declare PtrSafe Function ConnectToConnectionPoint Lib "shlwapi" Alias "#168" _
       (ByVal punk As stdole.IUnknown, _
        ByRef riidEvent As GUID, _
        ByVal fConnect As Long, _
        ByVal punkTarget As stdole.IUnknown, _
        ByRef pdwCookie As Long, _
        Optional ByVal ppcpOut As LongPtr) As Long
#Else
  Private Declare Function ConnectToConnectionPoint Lib "shlwapi" Alias "#168" _
       (ByVal punk As stdole.IUnknown, _
        ByRef riidEvent As GUID, _
        ByVal fConnect As Long, _
        ByVal punkTarget As stdole.IUnknown, _
        ByRef pdwCookie As Long, _
        Optional ByVal ppcpOut As Long) As Long
#End If

Private Cookie As Long  'pdwCookie of ConnectToConnectionPoint



'------[ Objects of Event-Listener ]----------------------------
Private WithEvents MyCtrlLbl As MSForms.Label
Attribute MyCtrlLbl.VB_VarHelpID = -1
Private WithEvents MyCtrlCmd As MSForms.CommandButton
Attribute MyCtrlCmd.VB_VarHelpID = -1
Private WithEvents MyCtrlTxt As MSForms.TextBox
Attribute MyCtrlTxt.VB_VarHelpID = -1
Private WithEvents MyCtrlChk As MSForms.CheckBox
Attribute MyCtrlChk.VB_VarHelpID = -1
Private WithEvents MyCtrlOpt As MSForms.OptionButton
Attribute MyCtrlOpt.VB_VarHelpID = -1
Private WithEvents MyCtrlTgl As MSForms.ToggleButton
Attribute MyCtrlTgl.VB_VarHelpID = -1
Private WithEvents MyCtrlCbo As MSForms.ComboBox
Attribute MyCtrlCbo.VB_VarHelpID = -1
Private WithEvents MyCtrlSpn As MSForms.SpinButton
Attribute MyCtrlSpn.VB_VarHelpID = -1

'In the child class, Frame/MultiPage are added for [FakeExit].
Private WithEvents MyCtrlFra As MSForms.Frame
Attribute MyCtrlFra.VB_VarHelpID = -1
Private WithEvents MyCtrlMlt As MSForms.MultiPage
Attribute MyCtrlMlt.VB_VarHelpID = -1
Private MyCtrlMlt_OldPage As Integer       'Previous page number of Page_Change event.


'MyCtrl is the Representative-Control.
'Enter/Exit/BeforeUpdate/AfterUpdate are connected to MyCtrl
'by ConnectToConnectionPoint.
Private MyCtrl As Object
Attribute MyCtrl.VB_VarHelpID = -1

Private MyIndex As Integer          'Index of the control
Private MyParent As clsBpca         'Reference to clsBpca object
Private MyEnableEvents As Boolean
Private MyFontColor As Long         'Initial Foreground Color
Private MyBackColor As Long         'Initial Background Color
Private blnParent As Boolean

'---------------------------------------------------
'Raise Event(Enable or Not enable)
Private lngEventState As Long

Private blnEventChange As Boolean           '[ 1bit]
Private blnEventClick As Boolean            '[ 2]
Private blnEventDblClick As Boolean         '[ 3]
Private blnEventKeyDown As Boolean          '[ 4]
Private blnEventKeyPress As Boolean         '[ 5]
Private blnEventKeyUp As Boolean            '[ 6]
Private blnEventMouseMove As Boolean        '[ 7]
Private blnEventMouseDown As Boolean        '[ 8]
Private blnEventMouseUp As Boolean          '[ 9]
Private blnEventDropBtnClick As Boolean     '[10]
Private blnEventSpinDown As Boolean         '[11]
Private blnEventSpinUp As Boolean           '[12]
Private blnEventEnter As Boolean            '[13]
Private blnEventExit As Boolean             '[14]
Private blnEventBeforeUpdate As Boolean     '[15]
Private blnEventAfterUpdate As Boolean      '[16]
Private blnEventFakeExit As Boolean         '[17]

'=====[ Event connection by ConnectToConnectionPoint ]=============
Private Sub ConnectEvent(ByVal Connect As Boolean)
Dim IID_IDispatch As GUID

    ' GUID {00020400-0000-0000-C000000000000046}
    With IID_IDispatch
        .Data1 = &H20400
        .Data4(0) = &HC0
        .Data4(7) = &H46
    End With
    
    Call ConnectToConnectionPoint _
            (Me, IID_IDispatch, Connect, MyCtrl, Cookie, 0&)
End Sub

'=============================================
Private Sub Class_Initialize()
    blnParent = False
    MyIndex = 0
    MyEnableEvents = True
End Sub

'=============================================
Public Sub Clear()
    If (Cookie <> 0) Then
        'Destruction of the event connection
        'with MyCtrl by ConnectToConnectionPoint
        Call ConnectEvent(False)
        Cookie = 0
    End If
    
    Set MyCtrlLbl = Nothing
    Set MyCtrlCmd = Nothing
    Set MyCtrlTxt = Nothing
    Set MyCtrlChk = Nothing
    Set MyCtrlOpt = Nothing
    Set MyCtrlTgl = Nothing
    Set MyCtrlCbo = Nothing
    Set MyCtrlSpn = Nothing
    Set MyCtrlFra = Nothing
    Set MyCtrlMlt = Nothing

    Set MyCtrl = Nothing
    Set MyParent = Nothing
    blnParent = False
    MyIndex = 0
End Sub

'=============================================
Public Property Let Item(NewCtrl As Object)
    Set MyCtrl = NewCtrl
    MyFontColor = MyCtrl.ForeColor  'Store the initial Foreground Color
    MyBackColor = MyCtrl.BackColor  'Store the initial Background Color
    
    '[EventSet] has been carried out earlier from [Item].
    If ((lngEventState And (BPCA2_EnterExit + BPCA2_BAUpdate)) = 0) Then
        'There are no instructions of [Enter,Exit,BeforeUpdate,AfterUpdate].
    Else
        'Event connection with MyCtrl by ConnectToConnectionPoint
        Call ConnectEvent(True)
    End If
    
    Select Case TypeName(NewCtrl)
      Case "Label": Set MyCtrlLbl = NewCtrl
      Case "CommandButton": Set MyCtrlCmd = NewCtrl
      Case "TextBox": Set MyCtrlTxt = NewCtrl
      Case "CheckBox": Set MyCtrlChk = NewCtrl
      Case "OptionButton": Set MyCtrlOpt = NewCtrl
      Case "ToggleButton": Set MyCtrlTgl = NewCtrl
      Case "ComboBox": Set MyCtrlCbo = NewCtrl
      Case "SpinButton": Set MyCtrlSpn = NewCtrl
      Case "Frame": Set MyCtrlFra = NewCtrl
      Case "MultiPage"
                Set MyCtrlMlt = NewCtrl
                MyCtrlMlt_OldPage = MyCtrlMlt.Value
    End Select
End Property

Public Property Get Item() As Object
    Set Item = MyCtrl
End Property

'=============================================
Public Property Let Index(NewIndex As Integer)
    MyIndex = NewIndex
End Property

Public Property Get Index() As Integer
    Index = MyIndex
End Property

'=============================================
Public Property Let EnableEvents(NewEnableEvents As Boolean)
    MyEnableEvents = NewEnableEvents
End Property

Public Property Get EnableEvents() As Boolean
    EnableEvents = MyEnableEvents
End Property

'=============================================
Public Property Get InitFColor() As Long
    InitFColor = MyFontColor
End Property

'=============================================
Public Property Get InitBColor() As Long
    InitBColor = MyBackColor
End Property

'=============================================
'clsBpca class of the parent of this class
Public Property Let Parent(NewParent As clsBpca)
    blnParent = True
    Set MyParent = NewParent
End Property

Public Property Get Parent() As clsBpca
    Set Parent = MyParent
End Property

'=============================================
Public Property Let EventSet(NewEvent As Long)
'Break numerical value into a bit and substitute it for each flag

    lngEventState = NewEvent
    
    blnEventChange = ((NewEvent And BPCA2_Change) = BPCA2_Change)
    blnEventClick = ((NewEvent And BPCA2_Click) = BPCA2_Click)
    blnEventDblClick = ((NewEvent And BPCA2_DblClick) = BPCA2_DblClick)
    blnEventKeyDown = ((NewEvent And BPCA2_KeyDown) = BPCA2_KeyDown)
    blnEventKeyPress = ((NewEvent And BPCA2_KeyPress) = BPCA2_KeyPress)
    blnEventKeyUp = ((NewEvent And BPCA2_KeyUp) = BPCA2_KeyUp)
    blnEventMouseMove = ((NewEvent And BPCA2_MouseMove) = BPCA2_MouseMove)
    blnEventMouseDown = ((NewEvent And BPCA2_MouseDown) = BPCA2_MouseDown)
    blnEventMouseUp = ((NewEvent And BPCA2_MouseUp) = BPCA2_MouseUp)
    blnEventDropBtnClick = ((NewEvent And BPCA2_DropBtnClick) = BPCA2_DropBtnClick)
    blnEventSpinDown = ((NewEvent And BPCA2_SpinDown) = BPCA2_SpinDown)
    blnEventSpinUp = ((NewEvent And BPCA2_SpinUp) = BPCA2_SpinUp)
    
    blnEventEnter = ((NewEvent And BPCA2_Enter) = BPCA2_Enter)
    blnEventExit = ((NewEvent And BPCA2_Exit) = BPCA2_Exit)
    blnEventBeforeUpdate = ((NewEvent And BPCA2_BeforeUpdate) = BPCA2_BeforeUpdate)
    blnEventAfterUpdate = ((NewEvent And BPCA2_AfterUpdate) = BPCA2_AfterUpdate)
    
    blnEventFakeExit = ((NewEvent And BPCA2_FakeExit) = BPCA2_FakeExit)
End Property

'=============================================
' I return Variant array for the event raise classification
' that I received in EventSet property.
'  0: Long type, 1-16: Boolean type
'
'  [0] The numerical value that I received in EventSet
'  [1] Change, [2]Click, [3]DblClick
'  [4] KeyDown, [5]KeyPress, [6]KeyUp
'  [7] MouseMove, [8]MouseDown, [9]MouseUp
'  [10] DropBtnClick), [11]SpinDown, [12]SpinUp
'  [13] Enter, [14] Exit, [15] BeforeUpdate, [16] AfterUpdate
'  [17] FakeExit

Public Property Get EventState() As Variant
    EventState = Array(lngEventState, _
                       blnEventChange, blnEventClick, blnEventDblClick, _
                       blnEventKeyDown, blnEventKeyPress, blnEventKeyUp, _
                       blnEventMouseMove, blnEventMouseDown, blnEventMouseUp, _
                       blnEventDropBtnClick, blnEventSpinDown, blnEventSpinUp, _
                       blnEventEnter, blnEventExit, blnEventBeforeUpdate, blnEventAfterUpdate, _
                       blnEventFakeExit)
End Property


'===================================================================
'===== Event Listener section                     ==================
'===================================================================
' When it receive an event, it notify Parent-class-object.
'
' (Note)
' 1. In the class module, we cannot receive Enter, Exit, BeforeUpdate
'    and AfterUpdate in MsForms. Therefore I implement it using
'    ConnectToConnectionPoint of API.
'
' 2. Therefore, Dual Event-Listeners are implemented for one control
'    registered with clsBpcaCh. (It works in Parallel together.)
'
' 3. In addition, we can receive all events including Chage, Click etc.
'    using ConnectToConnectionPoint.
'    Therefore, I can unify it in event listeners by ConnectToConnectionPoint.
'
' 4. However, this class is a public module.
'    I think that it is not good to compose it of only an incomprehensible
'    macro code for general VBA user.
'    Therefore, I dare to implement it in Dual Event-Listeners (The event that
'    we can receive in MsForms makes normal event macro. Enter event, etc. are
'    special. It is implemented in ConnectToConnectionPoint.)


'=========================================================================
' [ Enter/Exit/BeforeUpdate/AfterUpdate ] by ConnectToConnectionPoint

' "MyCtrl_" is not necessary for a procedure name.
' It is connected by ConnectToConnectionPoint.
'
' In the export file (clsBpcaCh.cls), the Attribute statement
' is embedded at the comment position below.
' You cannot see it in the VBE code window, but you can see it
' in the export file(clsBpcaCh.cls).

' List of VB_UserMemId
'   AfterUpdate     &H80018200 = -2147384832
'   BeforeUpdate    &H80018201 = -2147384831
'   Enter           &H80018202 = -2147384830
'   Exit            &H80018203 = -2147384829
  
Public Sub HookEnter()
Attribute HookEnter.VB_UserMemId = -2147384830
'Attribute HookEnter.VB_UserMemId = -2147384830
    If (blnParent And blnEventEnter And MyEnableEvents) Then
        MyParent.RaiseEnter MyIndex
    End If
End Sub
  
Public Sub HookExit(ByVal Cancel As MSForms.ReturnBoolean)
Attribute HookExit.VB_UserMemId = -2147384829
'Attribute HookExit.VB_UserMemId = -2147384829
    If (blnParent And blnEventExit And MyEnableEvents) Then
        Select Case TypeName(MyCtrl)
          Case "Frame", "MultiPage"
            MyParent.Exit4FakeExit MyIndex
          Case Else
            MyParent.RaiseExit MyIndex, Cancel
        End Select
    End If
End Sub
  
Public Sub HookBeforeUpdate(ByVal Cancel As MSForms.ReturnBoolean)
Attribute HookBeforeUpdate.VB_UserMemId = -2147384831
'Attribute HookBeforeUpdate.VB_UserMemId = -2147384831
    If (blnParent And blnEventBeforeUpdate And MyEnableEvents) Then
        MyParent.RaiseBeforeUpdate MyIndex, Cancel
    End If
End Sub
  
Public Sub HookAfterUpdate()
Attribute HookAfterUpdate.VB_UserMemId = -2147384832
'Attribute HookAfterUpdate.VB_UserMemId = -2147384832
    If (blnParent And blnEventAfterUpdate And MyEnableEvents) Then
        MyParent.RaiseAfterUpdate MyIndex
    End If
End Sub


'==============================================================
' [ except Enter/Exit/BeforeUpdate/AfterUpdate ] by MsForms
'
' The event that we can receive in MsForms
' supports by event procedure for WithEvents as usual.

'----[ Label ]--------------------------------------
Private Sub MyCtrlLbl_Click()
    If (blnParent And blnEventClick And MyEnableEvents) Then
        MyParent.RaiseClick MyIndex
    End If
End Sub

Private Sub MyCtrlLbl_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlLbl_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlLbl_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlLbl_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

'----[ CommandButton ]--------------------------------------
Private Sub MyCtrlCmd_Click()
    If (blnParent And blnEventClick And MyEnableEvents) Then
        MyParent.RaiseClick MyIndex
    End If
End Sub

Private Sub MyCtrlCmd_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlCmd_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlCmd_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlCmd_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlCmd_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlCmd_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlCmd_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

'----[ TextBox ]--------------------------------------
Private Sub MyCtrlTxt_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.RaiseChange MyIndex
    End If
End Sub

Private Sub MyCtrlTxt_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlTxt_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlTxt_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlTxt_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlTxt_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlTxt_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlTxt_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

'----[ CheckBox ]--------------------------------------
Private Sub MyCtrlChk_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.RaiseChange MyIndex
    End If
End Sub

Private Sub MyCtrlChk_Click()
    If (blnParent And blnEventClick And MyEnableEvents) Then
        MyParent.RaiseClick MyIndex
    End If
End Sub

Private Sub MyCtrlChk_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlChk_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlChk_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlChk_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlChk_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlChk_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlChk_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

'----[ OptionButtton ]--------------------------------------
Private Sub MyCtrlOpt_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.RaiseChange MyIndex
    End If
End Sub

Private Sub MyCtrlOpt_Click()
    If (blnParent And blnEventClick And MyEnableEvents) Then
        MyParent.RaiseClick MyIndex
    End If
End Sub

Private Sub MyCtrlOpt_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlOpt_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlOpt_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlOpt_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlOpt_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlOpt_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlOpt_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

'----[ ToggleButtton ]--------------------------------------
Private Sub MyCtrlTgl_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.RaiseChange MyIndex
    End If
End Sub

Private Sub MyCtrlTgl_Click()
    If (blnParent And blnEventClick And MyEnableEvents) Then
        MyParent.RaiseClick MyIndex
    End If
End Sub

Private Sub MyCtrlTgl_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlTgl_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlTgl_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlTgl_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlOTgl_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlTgl_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlTgl_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

'----[ ComboBox ]--------------------------------------
Private Sub MyCtrlCbo_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.RaiseChange MyIndex
    End If
End Sub

Private Sub MyCtrlCbo_Click()
    If (blnParent And blnEventClick And MyEnableEvents) Then
        MyParent.RaiseClick MyIndex
    End If
End Sub

Private Sub MyCtrlCbo_DblClick(ByVal Cancel As MSForms.ReturnBoolean)
    If (blnParent And blnEventDblClick And MyEnableEvents) Then
        MyParent.RaiseDblClick MyIndex, Cancel
    End If
End Sub

Private Sub MyCtrlCbo_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlCbo_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlCbo_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlCbo_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseMove And MyEnableEvents) Then
        MyParent.RaiseMouseMove MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlCbo_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseDown And MyEnableEvents) Then
        MyParent.RaiseMouseDown MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlCbo_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
    If (blnParent And blnEventMouseUp And MyEnableEvents) Then
        MyParent.RaiseMouseUp MyIndex, Button, Shift, X, Y
    End If
End Sub

Private Sub MyCtrlCbo_DropButtonClick()
    If (blnParent And blnEventDropBtnClick And MyEnableEvents) Then
        MyParent.RaiseDropButtonClick MyIndex
    End If
End Sub

'----[ SpinButton ]--------------------------------------
Private Sub MyCtrlSpn_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.RaiseChange MyIndex
    End If
End Sub

Private Sub MyCtrlSpn_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyDown And MyEnableEvents) Then
        MyParent.RaiseKeyDown MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlSpn_KeyPress(ByVal KeyAscii As MSForms.ReturnInteger)
    If (blnParent And blnEventKeyPress And MyEnableEvents) Then
        MyParent.RaiseKeyPress MyIndex, KeyAscii
    End If
End Sub

Private Sub MyCtrlSpn_KeyUp(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
    If (blnParent And blnEventKeyUp And MyEnableEvents) Then
        MyParent.RaiseKeyUp MyIndex, KeyCode, Shift
    End If
End Sub

Private Sub MyCtrlSpn_SpinDown()
    If (blnParent And blnEventSpinDown And MyEnableEvents) Then
        MyParent.RaiseSpinDown MyIndex
    End If
End Sub

Private Sub MyCtrlSpn_SpinUp()
    If (blnParent And blnEventSpinUp And MyEnableEvents) Then
        MyParent.RaiseSpinUp MyIndex
    End If
End Sub

'----[ MultiPage ]--------------------------------------
Private Sub MyCtrlMlt_Change()
    If (blnParent And blnEventChange And MyEnableEvents) Then
        MyParent.Change4FakeExit MyIndex, MyCtrlMlt_OldPage
    End If
    
    MyCtrlMlt_OldPage = MyCtrlMlt.Value
End Sub



